/*
 * StringSplit.java
 *
 * Created on January 3, 2006, 2:08 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package util;


public class StringSplitCSV {
    
    public static String[] split(String s, String delims) {
        int count = 0;
        int[] delimiterPositions = new int[s.length() + 1];
        char[] chars = new char[s.length()];
        char[] delimChars = new char[delims.length()];

        s.getChars(0, s.length(), chars, 0);
        delims.getChars(0, delims.length(), delimChars, 0);
        
        delimiterPositions[0] = -1;
        for (int i=0; i < chars.length; i++) {
            for (int j=0; j < delimChars.length; j++) {
                if (chars[i] == delimChars[j]) {
                    delimiterPositions[++count] = i;
                    break;
                }
            }
        }
        count++;
        delimiterPositions[count] = chars.length;

        //If last entry would be the null string, then don't include it.
        //Not good for CSV-type files, but matches String.split().
//        if (delimiterPositions[count - 1] == chars.length - 1) {
//            count--;
//        }
        
        String[] result = new String[count];
        
        for (int i=0; i < count; i++) {
            result[i] = s.substring(delimiterPositions[i]+1, delimiterPositions[i+1]);
        }
        return result;
    }
    
//    public static void main(String[] args) {
//        String[] result = StringSplit.split("\tThis is a string. ", " \t");
//    }
}
