package loc;
/*
 * LocationMidlet.java
 *
 * Created on November 24, 2005, 10:37 PM
 */

import javax.microedition.io.Connector;
import javax.microedition.location.Criteria;
import javax.microedition.location.Location;
import javax.microedition.location.LocationException;
import javax.microedition.location.LocationListener;
import javax.microedition.location.QualifiedCoordinates;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.location.LocationProvider;

public class LocationMidlet extends MIDlet implements CommandListener,
        LocationListener {
    
    LocationProvider locationProvider;
    
    /**
     * Creates a new instance of LocationMidlet
     */
    public LocationMidlet() {
    }
    
    private Form locForm;//GEN-BEGIN:MVDFields
    private StringItem nmeaStringItem;
    private Command exitCommand;
    private StringItem latStringItem;
    private StringItem lonStringItem;
    private TextField mimeText;
    private ChoiceGroup intervalPostGroup;
    private Spacer spacer1;//GEN-END:MVDFields
    
    /** This method initializes UI of the application.//GEN-BEGIN:MVDMethods
     */
    private void initialize() {
        getDisplay().setCurrent(get_locForm());
    }//GEN-END:MVDMethods
    
    /** Called by the system to indicate that a command has been invoked on a particular displayable.//GEN-BEGIN:MVDCABegin
     * @param command the Command that ws invoked
     * @param displayable the Displayable on which the command was invoked
     */
    public void commandAction(Command command, Displayable displayable) {//GEN-END:MVDCABegin
        // Insert global pre-action code here
        if (displayable == locForm) {//GEN-BEGIN:MVDCABody
            if (command == exitCommand) {//GEN-END:MVDCABody
                // Insert pre-action code here
                exitMIDlet();//GEN-LINE:MVDCAAction3
                // Insert post-action code here
            }//GEN-BEGIN:MVDCACase3
        }//GEN-END:MVDCACase3
        // Insert global post-action code here
}//GEN-LINE:MVDCAEnd
    
    /**
     * This method should return an instance of the display.
     */
    public Display getDisplay() {//GEN-FIRST:MVDGetDisplay
        //readLocation();
        return Display.getDisplay(this);
    }//GEN-LAST:MVDGetDisplay
    
    /**
     * This method should exit the midlet.
     */
    public void exitMIDlet() {//GEN-FIRST:MVDExitMidlet
        getDisplay().setCurrent(null);
        destroyApp(true);
        notifyDestroyed();
    }//GEN-LAST:MVDExitMidlet
    
    /** This method returns instance for locForm component and should be called instead of accessing locForm field directly.//GEN-BEGIN:MVDGetBegin2
     * @return Instance for locForm component
     */
    public Form get_locForm() {
        if (locForm == null) {//GEN-END:MVDGetBegin2
            // Insert pre-init code here
            locForm = new Form(null, new Item[] {//GEN-BEGIN:MVDGetInit2
                get_nmeaStringItem(),
                        get_mimeText(),
                        get_latStringItem(),
                        get_lonStringItem(),
                        get_spacer1(),
                        get_intervalPostGroup()
            });
            locForm.addCommand(get_exitCommand());
            locForm.setCommandListener(this);//GEN-END:MVDGetInit2
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd2
        return locForm;
    }//GEN-END:MVDGetEnd2
    
    /** This method returns instance for nmeaStringItem component and should be called instead of accessing nmeaStringItem field directly.//GEN-BEGIN:MVDGetBegin4
     * @return Instance for nmeaStringItem component
     */
    public StringItem get_nmeaStringItem() {
        if (nmeaStringItem == null) {//GEN-END:MVDGetBegin4
            // Insert pre-init code here
            nmeaStringItem = new StringItem("NMEA", "---");//GEN-LINE:MVDGetInit4
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd4
        return nmeaStringItem;
    }//GEN-END:MVDGetEnd4
    
    /** This method returns instance for exitCommand component and should be called instead of accessing exitCommand field directly.//GEN-BEGIN:MVDGetBegin5
     * @return Instance for exitCommand component
     */
    public Command get_exitCommand() {
        if (exitCommand == null) {//GEN-END:MVDGetBegin5
            // Insert pre-init code here
            exitCommand = new Command("Exit", Command.EXIT, 1);//GEN-LINE:MVDGetInit5
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd5
        return exitCommand;
    }//GEN-END:MVDGetEnd5
    
    /** This method returns instance for latStringItem component and should be called instead of accessing latStringItem field directly.//GEN-BEGIN:MVDGetBegin6
     * @return Instance for latStringItem component
     */
    public StringItem get_latStringItem() {
        if (latStringItem == null) {//GEN-END:MVDGetBegin6
            // Insert pre-init code here
            latStringItem = new StringItem("Lat", "?");//GEN-LINE:MVDGetInit6
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd6
        return latStringItem;
    }//GEN-END:MVDGetEnd6
    
    /** This method returns instance for lonStringItem component and should be called instead of accessing lonStringItem field directly.//GEN-BEGIN:MVDGetBegin7
     * @return Instance for lonStringItem component
     */
    public StringItem get_lonStringItem() {
        if (lonStringItem == null) {//GEN-END:MVDGetBegin7
            // Insert pre-init code here
            lonStringItem = new StringItem("Lon", "?");//GEN-LINE:MVDGetInit7
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd7
        return lonStringItem;
    }//GEN-END:MVDGetEnd7

    /** This method returns instance for mimeText component and should be called instead of accessing mimeText field directly.//GEN-BEGIN:MVDGetBegin8
     * @return Instance for mimeText component
     */
    public TextField get_mimeText() {
        if (mimeText == null) {//GEN-END:MVDGetBegin8
            // Insert pre-init code here
            mimeText = new TextField(null, null, 120, TextField.ANY);//GEN-LINE:MVDGetInit8
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd8
        return mimeText;
    }//GEN-END:MVDGetEnd8

    /** This method returns instance for intervalPostGroup component and should be called instead of accessing intervalPostGroup field directly.//GEN-BEGIN:MVDGetBegin9
     * @return Instance for intervalPostGroup component
     */
    public ChoiceGroup get_intervalPostGroup() {
        if (intervalPostGroup == null) {//GEN-END:MVDGetBegin9
            // Insert pre-init code here
            intervalPostGroup = new ChoiceGroup("Interval Posting", Choice.EXCLUSIVE, new String[] {//GEN-BEGIN:MVDGetInit9
                "On",
                        "Off"
            }, new Image[] {
                null,
                        null
            });
            intervalPostGroup.setSelectedFlags(new boolean[] {
                true,
                        false
            });//GEN-END:MVDGetInit9
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd9
        return intervalPostGroup;
    }//GEN-END:MVDGetEnd9

    /** This method returns instance for spacer1 component and should be called instead of accessing spacer1 field directly.//GEN-BEGIN:MVDGetBegin12
     * @return Instance for spacer1 component
     */
    public Spacer get_spacer1() {
        if (spacer1 == null) {//GEN-END:MVDGetBegin12
            // Insert pre-init code here
            spacer1 = new Spacer(1000, 1);//GEN-LINE:MVDGetInit12
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd12
        return spacer1;
    }//GEN-END:MVDGetEnd12
    
    public void locationUpdated(javax.microedition.location.LocationProvider
            provider, Location location) {
        nmeaStringItem.setText(location.getExtraInfo(
                "application/X-jsr179-location-nmea"));
        mimeText.setString(location.getExtraInfo(
                "text/plain"));
        QualifiedCoordinates qc = location.getQualifiedCoordinates();
        if (qc != null) {
            latStringItem.setText(Double.toString(qc.getLatitude()));
            lonStringItem.setText(Double.toString(qc.getLongitude()));
        }
    }
    
    public void providerStateChanged(
            javax.microedition.location.LocationProvider provider,
            int newState) {
        
    }
    
    public void startApp() {
        initialize();
        try {
            Criteria c = new Criteria();
            c.setCostAllowed(false);
            c.setHorizontalAccuracy(10);
            locationProvider = LocationProvider.getInstance(c);
            locationProvider.setLocationListener(this, 3, 2, 1);
        } catch (LocationException ex) {
            ex.printStackTrace();
        }
    }
    
    public void pauseApp() {
        locationProvider.setLocationListener(null, 0, 0, 0);
        locationProvider.reset();
    }
    
    public void destroyApp(boolean unconditional) {
        locationProvider.setLocationListener(null, 0, 0, 0);
        locationProvider.reset();
    }
}
